<?php
require_once dirname(__FILE__) . '/Connection.php';

final class Phostgres_Transaction {
	const NonTransaction = PGSQL_TRANSACTION_IDLE;
	const Idle = PGSQL_TRANSACTION_INTRANS;
	const Errored = PGSQL_TRANSACTION_INERROR;
	public $connection;

	function __construct(Phostgres_Connection $connection) {
		$this->connection = $connection;
		$connection->query('BEGIN');
	}

	function __get($name) {
		if($name == 'status')
			return pg_transaction_status($this->connection->resource);
	}

	function __isset($name) {
		return $name == 'status';
	}

	function rollback() {
		$this->connection->query('ROLLBACK');
	}

	function commit() {
		$this->connection->query('COMMIT');
	}

	function query() {
		$params = func_get_args();
		return call_user_func_array(array($this->connection, 'query'), $params);
	}

	function __destruct() {
		$this->rollback();
	}
}

